﻿using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Reflection;
using System.Data;
using System.IO;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;


namespace _3dedit
{
	
	enum EEditMode{
		EditScene=0,
		EditObject=1
	}
	enum EEditAction{
		None=0,
		SelectObject=1,
		MoveObject=2,
		CloneObject=3,
		EditObject=10,
		RemoveObject=11,
		SelectPoint=4,
		MovePoint=5,
		SplitEdge=6,
		ShrinkEdge=7,
		AddPoint=13,
		FlipEdge=12,
		Align=8,
		Align2=14,
		FillSelected=9
	}
	public enum EPickMode{
		PickFace=0,
		PickEdge=1,
		PickPoint=2
	}
	
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form {
		private System.Windows.Forms.ToolBarButton m_btnNew;
		private System.Windows.Forms.ToolBarButton m_btnOpen;
		private System.Windows.Forms.ToolBarButton m_btnSave;
		private System.Windows.Forms.ToolBarButton m_btnSolid;
		private System.Windows.Forms.ToolBarButton m_btnWireframe;
		private System.Windows.Forms.ToolBarButton m_btnEditObject;
		private System.Windows.Forms.ToolBarButton m_btnEditScene;
		private System.Windows.Forms.ToolBarButton m_btnSelectPoint;
		private System.Windows.Forms.ToolBarButton m_btnSplitEdge;
		private System.Windows.Forms.ToolBarButton m_btnJoinEdge;
		private System.Windows.Forms.ToolBarButton m_btnMovePts;
		private System.Windows.Forms.ToolBarButton m_btnMoveObject;
		private System.Windows.Forms.ToolBarButton m_btnNewObject;
		private System.Windows.Forms.ToolBar toolBar1;
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Panel panel2;
		private _3dedit.DXControl dxControl2;
		private System.Windows.Forms.ToolBarButton m_btnFillSelected;
		private System.Windows.Forms.ToolBarButton m_btnSelectColor;
		private System.Windows.Forms.ToolBarButton m_btnTarget;
		private System.Windows.Forms.ToolBarButton m_btnPaint;
		private System.Windows.Forms.ToolBarButton m_btnHole;
		private System.Windows.Forms.ToolBarButton m_btnCutHole;
		private System.Windows.Forms.ToolBarButton m_btnLoadObject;
		private System.Windows.Forms.ToolBarButton m_btnCloneObject;
		private System.Windows.Forms.ToolBarButton m_btnSelectObject;
		private System.Windows.Forms.ToolBarButton toolBarButton1;
		private System.Windows.Forms.ToolBarButton toolBarButton2;
		private System.Windows.Forms.ToolBarButton toolBarButton3;
		private System.Windows.Forms.ToolBarButton toolBarButton4;
		private System.Windows.Forms.ToolBarButton toolBarButton5;
		private System.Windows.Forms.ToolBarButton toolBarButton6;
		private System.Windows.Forms.ToolBarButton m_btnSmooth;
		private System.Windows.Forms.ToolBarButton m_btnSaveObject;
		private System.Windows.Forms.ToolBarButton toolBarButton7;
		private System.Windows.Forms.ToolBar m_tbShowMode;
		private System.Windows.Forms.ToolBar m_tbTargeting;
		private System.Windows.Forms.ToolBar m_tbEditScene;
		private System.Windows.Forms.ToolBar m_tbEditObject;
		private System.Windows.Forms.ToolBarButton m_btnRemoveObjects;
		private System.Windows.Forms.ToolBarButton m_btnAlign;
		private System.Windows.Forms.ToolBarButton m_btnTargetVert;
		private System.Windows.Forms.ToolBarButton m_btnRefresh;
		private System.Windows.Forms.ToolBarButton m_btnChangeBaseColor;
		private System.Windows.Forms.ToolBarButton m_btnFlip;
		private System.Windows.Forms.ToolBarButton m_btnAddPoint;
		private System.Windows.Forms.ToolBarButton m_btn_ALine;
		private System.Windows.Forms.ToolBar m_tbSpheres;
		private System.Windows.Forms.ToolBarButton m_btnSmallSphere;
		private System.Windows.Forms.ToolBarButton m_btnLargeSphere;
		private System.ComponentModel.IContainer components;

		public Form1() {
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//

			// 
			// dxControl2
			// 
			this.dxControl2 = new _3dedit.DXControl();


			this.dxControl2.Dock = System.Windows.Forms.DockStyle.Fill;
			this.dxControl2.Location = new System.Drawing.Point(0, 0);
			this.dxControl2.Name = "dxControl2";
			this.dxControl2.Size = new System.Drawing.Size(752, 279);
			this.dxControl2.TabIndex = 0;
			this.dxControl2.MouseUp += new MouseEventHandler(MouseUpEvt);
			this.dxControl2.MouseDown += new MouseEventHandler(MouseDownEvt);
			this.dxControl2.MouseMove += new MouseEventHandler(MouseEvt);

			this.panel2.Controls.Add(this.dxControl2);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing ) {
			if( disposing ) {
				if (components != null) {
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		//System.Resources.ResourceManager resources = new System.Resources.ResourceManager("_3dedit.Edit3D",Assembly.GetExecutingAssembly());

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager("_3dedit.Edit3D",Assembly.GetExecutingAssembly());
			this.m_btnNew = new System.Windows.Forms.ToolBarButton();
			this.m_btnOpen = new System.Windows.Forms.ToolBarButton();
			this.m_btnSave = new System.Windows.Forms.ToolBarButton();
			this.m_btnSolid = new System.Windows.Forms.ToolBarButton();
			this.m_btnWireframe = new System.Windows.Forms.ToolBarButton();
			this.m_btnEditObject = new System.Windows.Forms.ToolBarButton();
			this.m_btnEditScene = new System.Windows.Forms.ToolBarButton();
			this.m_btnSelectPoint = new System.Windows.Forms.ToolBarButton();
			this.m_btnSplitEdge = new System.Windows.Forms.ToolBarButton();
			this.m_btnJoinEdge = new System.Windows.Forms.ToolBarButton();
			this.m_btnMovePts = new System.Windows.Forms.ToolBarButton();
			this.m_btnMoveObject = new System.Windows.Forms.ToolBarButton();
			this.m_btnNewObject = new System.Windows.Forms.ToolBarButton();
			this.toolBar1 = new System.Windows.Forms.ToolBar();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.panel1 = new System.Windows.Forms.Panel();
			this.m_tbSpheres = new System.Windows.Forms.ToolBar();
			this.m_btnSmallSphere = new System.Windows.Forms.ToolBarButton();
			this.m_btnLargeSphere = new System.Windows.Forms.ToolBarButton();
			this.m_tbTargeting = new System.Windows.Forms.ToolBar();
			this.m_btnTarget = new System.Windows.Forms.ToolBarButton();
			this.m_btnTargetVert = new System.Windows.Forms.ToolBarButton();
			this.m_btnRefresh = new System.Windows.Forms.ToolBarButton();
			this.m_tbEditScene = new System.Windows.Forms.ToolBar();
			this.toolBarButton1 = new System.Windows.Forms.ToolBarButton();
			this.m_btnLoadObject = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton2 = new System.Windows.Forms.ToolBarButton();
			this.m_btnSelectObject = new System.Windows.Forms.ToolBarButton();
			this.m_btnCloneObject = new System.Windows.Forms.ToolBarButton();
			this.m_btnRemoveObjects = new System.Windows.Forms.ToolBarButton();
			this.m_tbEditObject = new System.Windows.Forms.ToolBar();
			this.toolBarButton7 = new System.Windows.Forms.ToolBarButton();
			this.m_btnSaveObject = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton3 = new System.Windows.Forms.ToolBarButton();
			this.m_btnFillSelected = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton4 = new System.Windows.Forms.ToolBarButton();
			this.m_btnAddPoint = new System.Windows.Forms.ToolBarButton();
			this.m_btnFlip = new System.Windows.Forms.ToolBarButton();
			this.m_btnHole = new System.Windows.Forms.ToolBarButton();
			this.m_btnCutHole = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton5 = new System.Windows.Forms.ToolBarButton();
			this.m_btnSmooth = new System.Windows.Forms.ToolBarButton();
			this.m_btnAlign = new System.Windows.Forms.ToolBarButton();
			this.m_btn_ALine = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton6 = new System.Windows.Forms.ToolBarButton();
			this.m_btnSelectColor = new System.Windows.Forms.ToolBarButton();
			this.m_btnPaint = new System.Windows.Forms.ToolBarButton();
			this.m_btnChangeBaseColor = new System.Windows.Forms.ToolBarButton();
			this.m_tbShowMode = new System.Windows.Forms.ToolBar();
			this.panel2 = new System.Windows.Forms.Panel();
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// m_btnNew
			// 
			this.m_btnNew.ImageIndex = 0;
			this.m_btnNew.ToolTipText = "Новая сцена";
			// 
			// m_btnOpen
			// 
			this.m_btnOpen.ImageIndex = 1;
			this.m_btnOpen.ToolTipText = "Прочитать сцену";
			// 
			// m_btnSave
			// 
			this.m_btnSave.ImageIndex = 2;
			this.m_btnSave.ToolTipText = "Сохранить сцену";
			// 
			// m_btnSolid
			// 
			this.m_btnSolid.ImageIndex = 3;
			this.m_btnSolid.Pushed = true;
			this.m_btnSolid.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			this.m_btnSolid.ToolTipText = "Показывать поверхность";
			// 
			// m_btnWireframe
			// 
			this.m_btnWireframe.ImageIndex = 4;
			this.m_btnWireframe.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			this.m_btnWireframe.ToolTipText = "Показывать ребра";
			// 
			// m_btnEditObject
			// 
			this.m_btnEditObject.ImageIndex = 6;
			this.m_btnEditObject.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			this.m_btnEditObject.ToolTipText = "Редактировать объект";
			// 
			// m_btnEditScene
			// 
			this.m_btnEditScene.ImageIndex = 7;
			this.m_btnEditScene.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			this.m_btnEditScene.ToolTipText = "Редактировать сцену";
			// 
			// m_btnSelectPoint
			// 
			this.m_btnSelectPoint.ImageIndex = 13;
			this.m_btnSelectPoint.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			this.m_btnSelectPoint.ToolTipText = "Выделить вершину ";
			// 
			// m_btnSplitEdge
			// 
			this.m_btnSplitEdge.ImageIndex = 14;
			this.m_btnSplitEdge.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			this.m_btnSplitEdge.ToolTipText = "Разрезать ребро";
			// 
			// m_btnJoinEdge
			// 
			this.m_btnJoinEdge.ImageIndex = 9;
			this.m_btnJoinEdge.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			this.m_btnJoinEdge.ToolTipText = "Стянуть ребро";
			// 
			// m_btnMovePts
			// 
			this.m_btnMovePts.ImageIndex = 17;
			this.m_btnMovePts.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			this.m_btnMovePts.ToolTipText = "Передвинуть выделенные вершины";
			// 
			// m_btnMoveObject
			// 
			this.m_btnMoveObject.ImageIndex = 20;
			this.m_btnMoveObject.ToolTipText = "Подвинуть объект";
			// 
			// m_btnNewObject
			// 
			this.m_btnNewObject.ImageIndex = 10;
			this.m_btnNewObject.ToolTipText = "Создать новый объект";
			// 
			// toolBar1
			// 
			this.toolBar1.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																						this.m_btnNew,
																						this.m_btnOpen,
																						this.m_btnSave});
			this.toolBar1.ButtonSize = new System.Drawing.Size(24, 24);
			this.toolBar1.Dock = System.Windows.Forms.DockStyle.None;
			this.toolBar1.DropDownArrows = true;
			this.toolBar1.ImageList = this.imageList1;
			this.toolBar1.Location = new System.Drawing.Point(0, 0);
			this.toolBar1.Name = "toolBar1";
			this.toolBar1.ShowToolTips = true;
			this.toolBar1.Size = new System.Drawing.Size(96, 36);
			this.toolBar1.TabIndex = 16;
			this.toolBar1.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.tbSystem_ButtonClick);
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(24, 24);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter1.Location = new System.Drawing.Point(0, 76);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(800, 4);
			this.splitter1.TabIndex = 18;
			this.splitter1.TabStop = false;
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.m_tbSpheres);
			this.panel1.Controls.Add(this.m_tbTargeting);
			this.panel1.Controls.Add(this.m_tbEditScene);
			this.panel1.Controls.Add(this.m_tbEditObject);
			this.panel1.Controls.Add(this.toolBar1);
			this.panel1.Controls.Add(this.m_tbShowMode);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(800, 76);
			this.panel1.TabIndex = 19;
			// 
			// m_tbSpheres
			// 
			this.m_tbSpheres.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																						   this.m_btnSmallSphere,
																						   this.m_btnLargeSphere});
			this.m_tbSpheres.ButtonSize = new System.Drawing.Size(24, 24);
			this.m_tbSpheres.Dock = System.Windows.Forms.DockStyle.None;
			this.m_tbSpheres.DropDownArrows = true;
			this.m_tbSpheres.ImageList = this.imageList1;
			this.m_tbSpheres.Location = new System.Drawing.Point(0, 40);
			this.m_tbSpheres.Name = "m_tbSpheres";
			this.m_tbSpheres.ShowToolTips = true;
			this.m_tbSpheres.Size = new System.Drawing.Size(64, 36);
			this.m_tbSpheres.TabIndex = 20;
			this.m_tbSpheres.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.tb_Spheres_ButtonClick);
			// 
			// m_btnSmallSphere
			// 
			this.m_btnSmallSphere.ImageIndex = 36;
			this.m_btnSmallSphere.ToolTipText = "Уменьшить точки";
			// 
			// m_btnLargeSphere
			// 
			this.m_btnLargeSphere.ImageIndex = 35;
			this.m_btnLargeSphere.ToolTipText = "Увеличить точки";
			// 
			// m_tbTargeting
			// 
			this.m_tbTargeting.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																							 this.m_btnTarget,
																							 this.m_btnTargetVert,
																							 this.m_btnRefresh});
			this.m_tbTargeting.ButtonSize = new System.Drawing.Size(24, 24);
			this.m_tbTargeting.Dock = System.Windows.Forms.DockStyle.None;
			this.m_tbTargeting.DropDownArrows = true;
			this.m_tbTargeting.ImageList = this.imageList1;
			this.m_tbTargeting.Location = new System.Drawing.Point(80, 40);
			this.m_tbTargeting.Name = "m_tbTargeting";
			this.m_tbTargeting.ShowToolTips = true;
			this.m_tbTargeting.Size = new System.Drawing.Size(96, 36);
			this.m_tbTargeting.TabIndex = 19;
			this.m_tbTargeting.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.tbTargeting_ButtonClick);
			// 
			// m_btnTarget
			// 
			this.m_btnTarget.ImageIndex = 5;
			this.m_btnTarget.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			this.m_btnTarget.ToolTipText = "Прицелиться";
			// 
			// m_btnTargetVert
			// 
			this.m_btnTargetVert.ImageIndex = 30;
			this.m_btnTargetVert.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			this.m_btnTargetVert.ToolTipText = "Целиться в вершину";
			// 
			// m_btnRefresh
			// 
			this.m_btnRefresh.ImageIndex = 29;
			this.m_btnRefresh.ToolTipText = "Обновить рисунок";
			// 
			// m_tbEditScene
			// 
			this.m_tbEditScene.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																							 this.m_btnEditScene,
																							 this.toolBarButton1,
																							 this.m_btnNewObject,
																							 this.m_btnLoadObject,
																							 this.toolBarButton2,
																							 this.m_btnSelectObject,
																							 this.m_btnMoveObject,
																							 this.m_btnCloneObject,
																							 this.m_btnRemoveObjects});
			this.m_tbEditScene.ButtonSize = new System.Drawing.Size(24, 24);
			this.m_tbEditScene.Dock = System.Windows.Forms.DockStyle.None;
			this.m_tbEditScene.DropDownArrows = true;
			this.m_tbEditScene.ImageList = this.imageList1;
			this.m_tbEditScene.Location = new System.Drawing.Point(200, 40);
			this.m_tbEditScene.Name = "m_tbEditScene";
			this.m_tbEditScene.ShowToolTips = true;
			this.m_tbEditScene.Size = new System.Drawing.Size(264, 36);
			this.m_tbEditScene.TabIndex = 18;
			this.m_tbEditScene.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.tbScene_ButtonClick);
			// 
			// toolBarButton1
			// 
			this.toolBarButton1.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// m_btnLoadObject
			// 
			this.m_btnLoadObject.ImageIndex = 21;
			this.m_btnLoadObject.ToolTipText = "Загрузить объект с диска";
			// 
			// toolBarButton2
			// 
			this.toolBarButton2.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// m_btnSelectObject
			// 
			this.m_btnSelectObject.ImageIndex = 23;
			this.m_btnSelectObject.ToolTipText = "Выбрать объект";
			// 
			// m_btnCloneObject
			// 
			this.m_btnCloneObject.ImageIndex = 24;
			this.m_btnCloneObject.ToolTipText = "Клонировать объект";
			// 
			// m_btnRemoveObjects
			// 
			this.m_btnRemoveObjects.ImageIndex = 27;
			this.m_btnRemoveObjects.ToolTipText = "Удалить объекты";
			// 
			// m_tbEditObject
			// 
			this.m_tbEditObject.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																							  this.m_btnEditObject,
																							  this.toolBarButton7,
																							  this.m_btnSaveObject,
																							  this.toolBarButton3,
																							  this.m_btnSelectPoint,
																							  this.m_btnFillSelected,
																							  this.toolBarButton4,
																							  this.m_btnAddPoint,
																							  this.m_btnFlip,
																							  this.m_btnJoinEdge,
																							  this.m_btnSplitEdge,
																							  this.m_btnHole,
																							  this.m_btnCutHole,
																							  this.toolBarButton5,
																							  this.m_btnMovePts,
																							  this.m_btnSmooth,
																							  this.m_btnAlign,
																							  this.m_btn_ALine,
																							  this.toolBarButton6,
																							  this.m_btnSelectColor,
																							  this.m_btnPaint,
																							  this.m_btnChangeBaseColor});
			this.m_tbEditObject.ButtonSize = new System.Drawing.Size(24, 24);
			this.m_tbEditObject.Dock = System.Windows.Forms.DockStyle.None;
			this.m_tbEditObject.DropDownArrows = true;
			this.m_tbEditObject.ImageList = this.imageList1;
			this.m_tbEditObject.Location = new System.Drawing.Point(200, 0);
			this.m_tbEditObject.Name = "m_tbEditObject";
			this.m_tbEditObject.ShowToolTips = true;
			this.m_tbEditObject.Size = new System.Drawing.Size(576, 36);
			this.m_tbEditObject.TabIndex = 17;
			this.m_tbEditObject.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.tbEditObject_ButtonClick);
			// 
			// toolBarButton7
			// 
			this.toolBarButton7.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// m_btnSaveObject
			// 
			this.m_btnSaveObject.ImageIndex = 22;
			this.m_btnSaveObject.ToolTipText = "Записать объект";
			// 
			// toolBarButton3
			// 
			this.toolBarButton3.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// m_btnFillSelected
			// 
			this.m_btnFillSelected.ImageIndex = 8;
			this.m_btnFillSelected.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			this.m_btnFillSelected.ToolTipText = "Выделить несколько вершин";
			// 
			// toolBarButton4
			// 
			this.toolBarButton4.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// m_btnAddPoint
			// 
			this.m_btnAddPoint.ImageIndex = 33;
			this.m_btnAddPoint.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			// 
			// m_btnFlip
			// 
			this.m_btnFlip.ImageIndex = 32;
			this.m_btnFlip.ToolTipText = "Переключить ребро";
			// 
			// m_btnHole
			// 
			this.m_btnHole.ImageIndex = 19;
			this.m_btnHole.ToolTipText = "Прорезать дырку";
			// 
			// m_btnCutHole
			// 
			this.m_btnCutHole.ImageIndex = 18;
			this.m_btnCutHole.ToolTipText = "Затянуть дырку";
			// 
			// toolBarButton5
			// 
			this.toolBarButton5.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// m_btnSmooth
			// 
			this.m_btnSmooth.ImageIndex = 25;
			this.m_btnSmooth.ToolTipText = "Сгладить фрагмент";
			// 
			// m_btnAlign
			// 
			this.m_btnAlign.ImageIndex = 26;
			this.m_btnAlign.Text = "Выровнять ребро";
			// 
			// m_btn_ALine
			// 
			this.m_btn_ALine.ImageIndex = 34;
			this.m_btn_ALine.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			this.m_btn_ALine.ToolTipText = "Подтянуть вершину к прямой/плоскости";
			// 
			// toolBarButton6
			// 
			this.toolBarButton6.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// m_btnSelectColor
			// 
			this.m_btnSelectColor.ImageIndex = 12;
			this.m_btnSelectColor.ToolTipText = "Выбрать цвет";
			// 
			// m_btnPaint
			// 
			this.m_btnPaint.ImageIndex = 11;
			this.m_btnPaint.ToolTipText = "Покрасить выделенные вершины";
			// 
			// m_btnChangeBaseColor
			// 
			this.m_btnChangeBaseColor.ImageIndex = 31;
			this.m_btnChangeBaseColor.ToolTipText = "Перекрасить фон объекта";
			// 
			// m_tbShowMode
			// 
			this.m_tbShowMode.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																							this.m_btnSolid,
																							this.m_btnWireframe});
			this.m_tbShowMode.ButtonSize = new System.Drawing.Size(24, 24);
			this.m_tbShowMode.Dock = System.Windows.Forms.DockStyle.None;
			this.m_tbShowMode.DropDownArrows = true;
			this.m_tbShowMode.ImageList = this.imageList1;
			this.m_tbShowMode.Location = new System.Drawing.Point(112, 0);
			this.m_tbShowMode.Name = "m_tbShowMode";
			this.m_tbShowMode.ShowToolTips = true;
			this.m_tbShowMode.Size = new System.Drawing.Size(64, 36);
			this.m_tbShowMode.TabIndex = 0;
			this.m_tbShowMode.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.tbShowMode_ButtonClick);
			// 
			// panel2
			// 
			this.panel2.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel2.Location = new System.Drawing.Point(0, 80);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(800, 520);
			this.panel2.TabIndex = 20;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(800, 600);
			this.Controls.Add(this.panel2);
			this.Controls.Add(this.splitter1);
			this.Controls.Add(this.panel1);
			this.Name = "Form1";
			this.Text = "3D Edit";
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		ArrayList m_objList=new ArrayList();
		ArrayList m_selObjects=new ArrayList();
		EEditMode m_EditMode=EEditMode.EditScene;				// scene or object
		MeshObj m_CurrentObject;
		EEditAction m_EditAction=EEditAction.None;			// what to move?
		Color m_CurrentColor=Color.Yellow;
		string sceneName=null;
		
		int ClickX,ClickY;
		private bool WantClick(){
			return true;
		}
		
		private void MouseDownEvt(object sender, MouseEventArgs e) {
			ClickX=e.X; ClickY=e.Y;
			MouseEvt(sender,e);
		}
		private void MouseUpEvt(object sender, MouseEventArgs e) {
			if(WantClick()){
				if(e.Clicks==2 || (ClickX==e.X && ClickY==e.Y)){
					ProcessClick(e);
				}
			}
			MouseEvt(sender,e);
		}
		
		private void MouseEvt(object sender, MouseEventArgs e) {
			if(e.Button==MouseButtons.Left){
				dxControl2.ProcessMouse(e,ETarget.TargetCamera,null);
			}else{
				OnAction func=null;
				ETarget targ=ETarget.TargetCamera;
				switch(m_EditAction){
					case EEditAction.MoveObject: 
						func=new OnAction(meMoveObject); 
						targ=ETarget.TargetObject;
						break;
					case EEditAction.MovePoint: 
						func=new OnAction(meMovePoints); 
						targ=ETarget.TargetObject;
						break;
				}
				dxControl2.ProcessMouse(e,targ,func);
			}
		}

		void meMoveObject(EAction action, ref Vector3 pt, ref Vector3 vec,double ang){ // rotate, slide, click, moveto (for camera) 
			switch(action){
				case EAction.ActionZoom:
					foreach(MeshObj me in m_selObjects){
						me.ScaleObject(1.0+ang);
					}
					break;
				case EAction.ActionSlide:
				case EAction.ActionMoveTo:
					foreach(MeshObj me in m_selObjects){
						me.MoveObject(ref vec);
					}
					break;
				case EAction.ActionRotate:
					foreach(MeshObj me in m_selObjects){
						me.RotateObject(ref pt,ref vec,ang);
					}
					break;
			}
			dxControl2.SetSceneChanged();
		}
		void meMovePoints(EAction action, ref Vector3 pt, ref Vector3 vec,double ang){ // rotate, slide, click, moveto (for camera) 
			switch(action){
				case EAction.ActionZoom:
					m_CurrentObject.ScaleSelectedPoints(1.0-ang);
					break;
				case EAction.ActionSlide:
				case EAction.ActionMoveTo:
					m_CurrentObject.MoveSelectedPoints(ref vec);
					break;
				case EAction.ActionRotate:
					m_CurrentObject.RotateSelectedPoints(ref pt,ref vec,ang);
					break;
			}
			dxControl2.SetSceneChanged();
		}
		
		public void ProcessClick(MouseEventArgs e){
			if(m_EditMode==EEditMode.EditScene){
				dxControl2.ProcessPick(e,ETarget.TargetObject,new OnAction(mkPickScene));
			}else{
				dxControl2.ProcessPick(e,ETarget.TargetObject,new OnAction(mkPickObject));
			}
		}
	
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() {
			Application.Run(new Form1());
		}

		private void tbShowMode_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e) {
			if(e==null) return;
			if(e.Button==m_btnSolid){
				m_btnSolid.Pushed=true;
				m_btnWireframe.Pushed=false;
				dxControl2.FillMode=FillMode.SOLID;
			}else if(e.Button==m_btnWireframe){
				m_btnSolid.Pushed=false;
				m_btnWireframe.Pushed=true;
				dxControl2.FillMode=FillMode.WIREFRAME;
			}
		
		}

		private void tbTargeting_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e) {
			if(e==null) return;
			if(e.Button==m_btnRefresh){
				RefreshView();
			}
		}
	
		private void tbScene_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e) {
			if(e==null) return;
			if(e.Button==m_btnEditScene){
				m_CurrentObject.UnselectAll();
				m_CurrentObject=null;
				m_btnEditScene.Pushed=true;
				m_btnEditObject.Pushed=false;
				ClearEOButtons(-1);
				ClearESButtons(1);
				m_EditMode=EEditMode.EditScene;
				m_EditAction=EEditAction.None;
				dxControl2.ClearMeshes();
				foreach(MeshObj obj in m_objList) dxControl2.AddMesh(obj);
				return;
			}
			if(m_EditMode!=EEditMode.EditScene) return;
			if(e.Button==m_btnNewObject){
				// TODO: Ask name
				MeshObj obj=MeshObj.NewMesh();				
				Vector3 shift=dxControl2.HalfCamera();
				obj.MkShift(ref shift);
				AddObject(obj);
				m_CurrentObject=obj;
				ToEditObject();
			}else if(e.Button==m_btnLoadObject){
				MeshObj obj=LoadObject();
				if(obj!=null){
					Vector3 shift=dxControl2.HalfCamera();
					obj.MkShift(ref shift);
					AddObject(obj);
					UnselectAll();
					m_CurrentObject=obj;
					MarkAsSelected(obj);
				}				
			}else if(e.Button==m_btnSelectObject){
				ClearESButtons(1);
				m_btnSelectObject.Pushed=true;
				m_EditAction=EEditAction.SelectObject;
			}else if(e.Button==m_btnMoveObject){
				ClearESButtons(1);
				m_btnMoveObject.Pushed=true;
				m_EditAction=EEditAction.MoveObject;
			}else if(e.Button==m_btnCloneObject){
				if(HaveSelected()){
					CloneSelected();
					ClearESButtons(1);
					m_btnMoveObject.Pushed=true;
					m_EditAction=EEditAction.MoveObject;
				}else{
					ClearESButtons(1);
					m_btnCloneObject.Pushed=true;
					m_EditAction=EEditAction.CloneObject;
				}
			}else if(e.Button==m_btnRemoveObjects){
				RemoveSelected();
			}
			dxControl2.SetSceneChanged();
		
		}
		void ToEditObject(){
			UnselectAll();
			m_btnEditScene.Pushed=false;
			m_btnEditObject.Pushed=true;
			ClearESButtons(-1);
			ClearEOButtons(1);
			m_EditMode=EEditMode.EditObject;
			m_EditAction=EEditAction.None;
			dxControl2.ClearMeshes();
			dxControl2.AddMesh(m_CurrentObject);
			dxControl2.ParkCamera(true);
		}
		void AddObject(MeshObj obj){
			m_objList.Add(obj);
			dxControl2.AddMesh(obj);
			dxControl2.ParkCamera(m_objList.Count==1);
		}
		void ClearEOButtons(int show){
			foreach(ToolBarButton tb in m_tbEditObject.Buttons){
				if(tb!=m_btnEditObject){
					tb.Pushed=false;
					if(show<0) tb.Enabled=false;
					if(show>0) tb.Enabled=true;
				}
			}
		}
		void ClearESButtons(int show){
			foreach(ToolBarButton tb in m_tbEditScene.Buttons){
				if(tb!=m_btnEditScene){
					tb.Pushed=false;
					if(show<0) tb.Enabled=false;
					if(show>0) tb.Enabled=true;
				}
			}
		}

		private void tbSystem_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e) {
			if(e==null) return;
			if(e.Button==m_btnNew){
				NewScene();
			}else if(e.Button==m_btnOpen){
				LoadScene();
			}else if(e.Button==m_btnSave){
				SaveScene();
			}
		
		}
	
		private void tbEditObject_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e) {
			if(e==null) return;
			if(e.Button==m_btnEditObject){
				MeshObj obj=GetSelectedObject();
				if(obj!=null){
					m_CurrentObject=obj;
					ToEditObject();
				}else{
					m_EditAction=EEditAction.EditObject;
				}
				return;
			}
			if(m_EditMode!=EEditMode.EditObject) return;
			if(m_CurrentObject==null) return;
			if(e.Button==m_btnSaveObject){
				SaveCurrentObject();
			}else if(e.Button==m_btnSplitEdge){
				ClearEOButtons(1);
				m_btnSplitEdge.Pushed=true;
				m_EditAction=EEditAction.SplitEdge;
			}else if(e.Button==m_btnJoinEdge){
				ClearEOButtons(1);
				m_btnJoinEdge.Pushed=true;
				m_EditAction=EEditAction.ShrinkEdge;
			}else if(e.Button==m_btnFlip){
				ClearEOButtons(1);
				m_btnFlip.Pushed=true;
				m_EditAction=EEditAction.FlipEdge;
			}else if(e.Button==m_btnAddPoint){
				ClearEOButtons(1);
				m_btnFlip.Pushed=true;
				m_EditAction=EEditAction.AddPoint;
			}else if(e.Button==m_btnHole){
				m_CurrentObject.MakeHole();
			}else if(e.Button==m_btnCutHole){
				m_CurrentObject.CutHole();
			}else if(e.Button==m_btnSelectPoint){
				ClearEOButtons(1);
				m_btnSelectPoint.Pushed=true;
				m_EditAction=EEditAction.SelectPoint;
			}else if(e.Button==m_btnFillSelected){
				ClearEOButtons(1);
				m_btnFillSelected.Pushed=true;
				m_EditAction=EEditAction.FillSelected;
			}else if(e.Button==m_btnMovePts){
				ClearEOButtons(1);
				m_btnMovePts.Pushed=true;
				m_EditAction=EEditAction.MovePoint;
			}else if(e.Button==m_btnAlign){
				ClearEOButtons(1);
				m_btnAlign.Pushed=true;
				m_EditAction=EEditAction.Align;
			}else if(e.Button==m_btn_ALine){
				ClearEOButtons(1);
				m_btn_ALine.Pushed=true;
				m_EditAction=EEditAction.Align2;
			}else if(e.Button==m_btnSmooth){
				m_CurrentObject.Smooth();
			}else if(e.Button==m_btnSelectColor){
				SelectColor();
			}else if(e.Button==m_btnPaint){
				m_CurrentObject.PaintSelected(m_CurrentColor);
			}else if(e.Button==m_btnChangeBaseColor){
				ChangeBaseColor();
			}
			dxControl2.SetSceneChanged();

		}

		void RefreshView(){
			dxControl2.ParkCamera(false);
			dxControl2.SetSceneChanged();
		}
	
		void MarkAsSelected(MeshObj obj){
			if(obj.IsSelected) return;
			obj.IsSelected=true;
			m_selObjects.Add(obj);
		}
		void MarkAsUnselected(MeshObj obj){
			if(!obj.IsSelected) return;
			obj.IsSelected=false;
			m_selObjects.Remove(obj);
		}
		void UnselectAll(){
			foreach(MeshObj obj in m_selObjects){
				obj.IsSelected=false;
			}
			m_selObjects.Clear();
		}

		MeshObj GetSelectedObject(){
			if(!HaveSelected()) return null;
			return (MeshObj)m_selObjects[0];
		}
		bool HaveSelected(){
			return m_selObjects.Count!=0;
		}
	
		MeshObj LoadObject(){
			OpenFileDialog sf=new OpenFileDialog();
			sf.DefaultExt=".msh";
			sf.Filter="Объект (*.msh)|*.msh";
			sf.InitialDirectory=Application.StartupPath+"\\objects";
			if(sf.ShowDialog()==DialogResult.OK){
				MeshObj obj=MeshObj.Load(sf.FileName);
				obj.Name=System.IO.Path.GetFileNameWithoutExtension(sf.FileName);
				return obj;
			}
			return null;
		}
		void SaveCurrentObject(){
			SaveFileDialog sf=new SaveFileDialog();
			sf.DefaultExt=".msh";
			sf.Filter="Объект (*.msh)|*.msh";
			sf.InitialDirectory=Application.StartupPath+"\\objects";
			if(m_CurrentObject.Name!=null){
				sf.FileName=m_CurrentObject.Name;
				sf.OverwritePrompt=false;
			}
			if(sf.ShowDialog()==DialogResult.OK){
				m_CurrentObject.Save(sf.FileName);
				m_CurrentObject.Name=System.IO.Path.GetFileNameWithoutExtension(sf.FileName);
			}

		}

		void SelectColor(){
			ColorDialog c=new ColorDialog();
			c.Color=m_CurrentColor;
			if(c.ShowDialog()==DialogResult.OK){
				m_CurrentColor=c.Color;
			}
		}

		void ChangeBaseColor(){
			ColorDialog c=new ColorDialog();
			c.Color=m_CurrentObject.BaseColor;
			if(c.ShowDialog()==DialogResult.OK){
				m_CurrentObject.BaseColor=c.Color;
				dxControl2.SetSceneChanged();
			}
		}

		void mkPickScene(EAction act,ref Vector3 pt,ref Vector3 vec,double ang){
			PointOnFace p;
			Vector3 ptx=new Vector3();
			MeshObj m0=null;
			double dd=-1;
			foreach(MeshObj m in m_objList){
				double d=m.GetIntersection(ref pt,ref vec,out p,EPickMode.PickFace);
				if(d>=0 && (dd<0 || d<dd)){
					m0=m;
					dd=d; ptx=p.WorldPoint;
				}
			}
			if(m0!=null){
				if(m_btnTarget.Pushed){
					dxControl2.SetPOV(ref ptx);
					m_btnTarget.Pushed=false;
				}else{
					if(m_EditAction==EEditAction.CloneObject){
						Vector3 v=dxControl2.CloneShift();
						MeshObj M1=new MeshObj(m0);
						M1.MkShift(ref v);
						AddObject(M1);
					}else if(m_EditAction==EEditAction.EditObject){
						m_CurrentObject=m0;
						ToEditObject();
					}else if(m_EditAction==EEditAction.RemoveObject){
						if(m0.IsSelected) m_selObjects.Remove(m0);
						m_objList.Remove(m0);
						dxControl2.RemoveMesh(m0);
					}else{
						if(act==EAction.ActionClick) UnselectAll();
						if(m0.IsSelected) MarkAsUnselected(m0);
						else MarkAsSelected(m0);
					}
					
				}
				dxControl2.SetSceneChanged();
			}
		}
		void CloneSelected(){
			ArrayList m_clones=new ArrayList();
			Vector3 v=dxControl2.CloneShift();
			foreach(MeshObj M in m_selObjects){
				MeshObj M1=new MeshObj(M);
				M1.MkShift(ref v);
				m_clones.Add(M1);
				AddObject(M1);
			}
			UnselectAll();
			foreach(MeshObj M in m_clones) MarkAsSelected(M);
		}
		void RemoveSelected(){
			foreach(MeshObj M in m_selObjects){
				m_objList.Remove(M);
				dxControl2.RemoveMesh(M);
			}
			m_selObjects.Clear();
		}

		/********** edit object *********/

		void mkPickObject(EAction act,ref Vector3 pt,ref Vector3 vec,double ang){
			if(m_CurrentObject==null) return;

			
			EPickMode pickMode=EPickMode.PickFace;
			if(m_btnTargetVert.Pushed){
				switch(m_EditAction){
					case EEditAction.AddPoint:
						break;
					case EEditAction.SelectPoint:
					case EEditAction.MovePoint:
					case EEditAction.FillSelected:
						pickMode=EPickMode.PickPoint;
						break;
					default:
						pickMode=EPickMode.PickEdge;
						break;
				}
			}
			
			PointOnFace p;
			double d=m_CurrentObject.GetIntersection(ref pt,ref vec,out p,pickMode);
			if(d<0) return;
			if(m_btnTarget.Pushed){
				dxControl2.SetPOV(ref p.WorldPoint);
				m_btnTarget.Pushed=false;
				return;
			}
			double u=p.u,v=p.v,w=1-u-v;
			int bestpt=(u<w && v<w) ? 0 : u<v ? 2 : 1;
			int bestface=0;
			double par=0;
			if(v<u && v<w){
				bestface=0; par=u/(u+w);
			}else if(u<w){
				bestface=2; par=w/(v+w);
			}else{
				bestface=1; par=v/(u+v);
			}
			
			EEditAction eact=m_EditAction;
			if(act==EAction.ActionClick){
				act=EAction.ActionShiftClick;
				eact=EEditAction.SelectPoint;
			}
			if(act==EAction.ActionCtrlClick){
				act=EAction.ActionCtrlShiftClick;
				eact=EEditAction.SelectPoint;
			}

			switch(eact){
				case EEditAction.SelectPoint:
				case EEditAction.MovePoint:
				default:
					if(act==EAction.ActionShiftClick) m_CurrentObject.UnselectAll();
					m_CurrentObject.SelectPoint(p.nface,bestpt);
					break;
				case EEditAction.SplitEdge:
					m_CurrentObject.SplitEdge(p.nface,bestface,par);
					break;
				case EEditAction.ShrinkEdge:
					m_CurrentObject.ShrinkEdge(p.nface,bestface,par);
					break;
				case EEditAction.FlipEdge:
					m_CurrentObject.FlipEdge(p.nface,bestface,par);
					break;
				case EEditAction.AddPoint:
					if(u<0.02 || v<0.02 || u+v>0.98) m_CurrentObject.SplitEdge(p.nface,bestface,par);
					else m_CurrentObject.AddPoint(p.nface,u,v);
					break;
				case EEditAction.Align:
					m_CurrentObject.AlignEdge(p.nface,bestface,par);
					break;
				case EEditAction.Align2:
					m_CurrentObject.AlignToLine(p.nface,bestface,par);
					break;
				case EEditAction.FillSelected:
					m_CurrentObject.FillSelected(p.nface,bestpt);
					break;
			}
		}
		private void tb_Spheres_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e) {
			if(e==null) return;
			if(e.Button==m_btnSmallSphere){
				MeshObj.ScaleSphere(0.5);
			}else if(e.Button==m_btnLargeSphere){
				MeshObj.ScaleSphere(2.0);
			}
			dxControl2.SetSceneChanged();
		}

		/*********** load/save scene ************/
		void NewScene(){
			dxControl2.ClearMeshes();
			m_objList.Clear();
			m_selObjects.Clear();
		}
		void LoadScene(){
			OpenFileDialog sf=new OpenFileDialog();
			sf.DefaultExt=".scn";
			sf.Filter="Сцена (*.scn)|*.scn";
			sf.InitialDirectory=Application.StartupPath+"\\scenes";
			if(sf.ShowDialog()==DialogResult.OK){
				NewScene();
				LoadScene(sf.FileName);
				sceneName=System.IO.Path.GetFileNameWithoutExtension(sf.FileName);
				foreach(MeshObj M in m_objList){
					dxControl2.AddMesh(M);
				}
			}
			dxControl2.ParkCamera(true);
		}

		void SaveScene(){
			SaveFileDialog sf=new SaveFileDialog();
			sf.DefaultExt=".scn";
			sf.Filter="Сцена (*.scn)|*.scn";
			sf.InitialDirectory=Application.StartupPath+"\\scenes";
			if(sceneName!=null){
				sf.FileName=sceneName;
				sf.OverwritePrompt=false;
			}
			if(sf.ShowDialog()==DialogResult.OK){
				SaveScene(sf.FileName);
				sceneName=System.IO.Path.GetFileNameWithoutExtension(sf.FileName);
			}

		}
		const int SCENE_TAG=0x004E4353;
		void SaveScene(string fn){
			try{
				BinaryWriter br=new BinaryWriter(new FileStream(fn,FileMode.Create));
				br.Write((Int32)SCENE_TAG);
				int np=m_objList.Count;
				MeshForm []mf=new MeshForm[np];
				for(int i=0;i<np;i++){
					MeshObj m=(MeshObj)m_objList[i];
					mf[i]=m.Form;
					mf[i].FormID=i;
				}
				int nf=np;
				br.Write(nf); // nforms
				br.Write(np); // nobjects
				for(int i=0;i<nf;i++){
					mf[i].SaveForm(br);
				}
				for(int i=0;i<np;i++){
					MeshObj m=(MeshObj)m_objList[i];
					m.SaveInfo(br);
				}
				br.Close();
			}catch{
			}
		}
		void LoadScene(string fn){
			try{
				BinaryReader br=new BinaryReader(new FileStream(fn,FileMode.Open));
				int tag=br.ReadInt32();
				if(tag!=SCENE_TAG) return;
				int nf=br.ReadInt32();
				int np=br.ReadInt32();

				MeshForm []mf=new MeshForm[nf];
				for(int i=0;i<nf;i++){
					mf[i]=MeshForm.LoadForm(br);
				}
				for(int i=0;i<np;i++){
					MeshObj m=MeshObj.LoadInfo(br,mf);
					m_objList.Add(m);
				}
				br.Close();
			}catch{
			}
		}

	}

}
